﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win;
using System.Diagnostics;

namespace WinGridMultyListCombo
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable ComboTable = new DataTable();
            ComboTable.Columns.Add("Name", typeof(string));
            ComboTable.Columns.Add("ID", typeof(int));
            for (int i = 0; i < 10; i++)
                ComboTable.Rows.Add("Name" + i.ToString(), i);
            MultiListCombo.DisplayMember = "Name";
            MultiListCombo.ValueMember = "ID";
            MultiListCombo.DataSource = ComboTable;

            UltraGridColumn checkColumn = MultiListCombo.DisplayLayout.Bands[0].Columns.Add("Choose");
            checkColumn.DataType = typeof(bool);
            checkColumn.Header.VisiblePosition = 0;
            MultiListCombo.CheckedListSettings.CheckStateMember = checkColumn.Key;
            MultiListCombo.CheckedListSettings.EditorValueSource = EditorWithComboValueSource.CheckedItems;
            MultiListCombo.CheckedListSettings.ItemCheckArea = Infragistics.Win.ItemCheckArea.Item;
          
            DataTable gridTable = new DataTable();
            gridTable.Columns.Add("Text", typeof(string));
            gridTable.Columns.Add("ID", typeof(string));
            for (int i = 0; i < 10; i++)
                gridTable.Rows.Add("Text" + i.ToString(), i.ToString());

            ultraGrid1.DataSource = gridTable;
            ultraGrid2.DataSource = gridTable;
        }

        private void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            UltraGridColumn col1 = e.Layout.Bands[0].Columns.Add("IDUn");
            col1.DataType = typeof(object);
            col1.EditorComponent = MultiListCombo; 
        }

        private void ultraGrid1_AfterCellUpdate(object sender, CellEventArgs e)
        {
            if (e.Cell.Column.Key == "IDUn")
            {
                List<object> val = e.Cell.Value as List<object>;
                if (val != null)
                {
                    string retval = string.Join(",", val.ToArray());
                    if (retval != e.Cell.Row.Cells["ID"].Value.ToString())
                    e.Cell.Row.Cells["ID"].Value = retval;
                }
            }
            if (e.Cell.Column.Key == "ID")
            {
                string val = e.Cell.Value as string;
                if (val != null)
                {
                    List<object> retval = new List<object>(StringToArray(val,",",typeof(int)));
                    e.Cell.Row.Cells["IDUn"].Value = retval;
                }
            }
        }

        public object[] StringToArray(string input, string separator, Type type)
        {
            string[] stringList = input.Split(separator.ToCharArray(),
                                              StringSplitOptions.RemoveEmptyEntries);
            object[] list = new object[stringList.Length];

            for (int i = 0; i < stringList.Length; i++)
            {
                list[i] = Convert.ChangeType(stringList[i], type);
            }

            return list;
        }
    }
}
